this.name = "GalNavy"; // don't change this name.
this.author = "matt634, Nemoricus";
this.copyright = "(c) matt634";
this.description = "This is the main script for Galactic Navy.";
this.version = "5.4.3 MOD 4";

"use strict";

//Things to do on start up, like initializing variables.
this.startUp = function()
{
//This code initializes any undefined Galactic Navy variables.
//This can probably be moved to a different section.

//This should set the victory bond count to zero if it is not yet defined when the player launches from a station.
	if(missionVariables.vicbond_count == undefined) missionVariables.vicbond_count = 0;

//This sets the status of the reserve enlistment offer.
	if(missionVariables.reserve_offer == undefined) missionVariables.reserve_offer = "OFFER_OPEN";

//This sets the reserve status of the player.
	if(missionVariables.reserve_status == undefined) missionVariables.reserve_status = "STATUS_CIVILIAN";

//This sets the sorties of the player and top reservists. Variable is incremented in ship scripts.
	if(missionVariables.player_sortie == undefined) {
	missionVariables.player_sortie = 0;
	missionVariables.powers_sortie = 31;
	missionVariables.zalack_sortie = 25;
	missionVariables.warrick_sortie = 27;
	missionVariables.xaquetl_sortie = 19;
	}

//This sets the initial status of scooped navy officers to zero.
	if(missionVariables.navy_officer_count == undefined && 0 < oolite.compareVersion("1.75")) missionVariables.navy_officer_count = 0;

//Initializing kill counter for Galactic Navy reserve duty.
	if(missionVariables.reserve_targets == undefined) missionVariables.reserve_targets = 0;
	if(this.reserve_enemy_ships == undefined) this.reserve_enemy_ships = 0;
	if(missionVariables.seccom_station == undefined) missionVariables.seccom_station = "SECCOM_REVISIT";
//End Galactic Navy Initialisation code.
}

//Stuff to do after launching from a station.
this.shipWillLaunchFromStation = function(station)
{
//If the player is in the mission system, this adds in the missions ships should they be absent.
	if(missionVariables.reserve_offer == "OFFER_ACCEPTED" && system.ID == missionVariables.reserve_planetnum) if(system.countShipsWithPrimaryRole("reserve-pirate") == 0 && system.countShipsWithPrimaryRole("galactic-navy-thargoid") <= 3) this.ReserveDutySystemSetUp();
	
// Add SecCom System ships if this is a SecCom system and that a SecCom station hasn't been spawned yet.
	if(this.SecComSystemCheck() && !(system.countShipsWithRole("navystat") > 0 || system.countShipsWithRole("navystat25") > 0 || system.countShipsWithRole("navystat50") > 0 || system.countShipsWithRole("navystat75") > 0)) this.SecComSystemSetUp();
}

//Some things to do as the player is leaving the mission system.
this.shipWillEnterWitchspace = function()
{
	var reserve_offer = missionVariables.reserve_offer;
	if(reserve_offer == "OFFER_COMPLETED" || reserve_offer == "OBJECTIVES_COMPLETE" || reserve_offer == "MISSION_ACCOMPLISHED") this.ReserveDutyCleanup();
}

//This section of code deals with things that need to done before the player arrives in a system.
this.shipWillExitWitchspace = function()
{
//Checking if the player has landed in interstellar space.
	if(system.isInterstellarSpace) {
/*
		if(Math.random() < .1) { // was < .26
			system.addShips("galnav-thargoid", 3);
		} else if(Math.random() < .05) {
			system.addShips("galnav-thargoid", 2);
			system.addShips("galnav-thargcruiser", 1);
		} else if(Math.random() < .03) {
			system.addShips("galnav-thargoid", 1);
			system.addShips("galnav-thargcruiser", 1);
			system.addShips("galnav-thargbatship", 1);
		} else if(Math.random() < .01) {
			system.addShips("galnav-thargcruiser", 2);
			system.addShips("galnav-thargbatship", 1);
		}

Math.log(player.score+1)	<- is the NATURAL LOG, not base-10 log!
 1 kill = 0 points
 2.718 kills = 1 point
 7.4 = 2
 20 = 3
 55 = 4
 149 = 5
 404 = 6
 1097 = 7
 2981 = 8
 8103 = 9
 22026 = 10
*/
		var pkillz = Math.log(player.score+1); // roughly 0 for 0-2 kills, 1 for 3-7 kills, 2 for 8-19, 3 for 20-54, 4 for 55-148, etc
//Randomly determining what ships to add to make for some interesting action.
//		if(Math.random() < .01) { // was < .26 or .02!
		if(Math.random() < .01 && pkillz < 7) { // was < .26 or .02! WON'T Happen after player has >1096 kills! FOR TESTING ONLY!
			if(Math.random() < .2) system.addShips("navy-boa2", 1)
//			system.addShips("navy-frigate", 1);
//			system.addShips("galnav-thargoid", 3);
			else if(Math.random() < .5) system.addGroup("navy-asp", 4)
			else system.addGroup("navy-asp", 2);
			log(this.name,pkillz," Galactic Navy ships to kill Thargoids added!");
		}
//		if(100*Math.random() < (2*pkillz -8) ) { // was < .26 ...now slowly gets uglier the more kills you have! Math.floor or Math.ceil not used to speed up checks
		if(100*Math.random() < (pkillz -5) ) { // was < .26 ...now slowly gets uglier the more kills you have! Math.floor or Math.ceil not used to speed up checks
			log(this.name,pkillz," Extra Galactic Navy type Thargoids added!");
			system.addGroup("galnav-thargoid", Math.ceil(pkillz-4) );
//			system.addGroup("galnav-thargoid", Math.ceil(2*pkillz-7) );
//			if(10*Math.random() < (pkillz -4) ) system.addGroup("galnav-thargcruiser", Math.ceil(0.5*pkillz-1) ); // same as:	if(100*Math.random() < (10*pkillz -40)) {
//			if(100*Math.random() < (2*pkillz) ) system.addGroup("galnav-thargcruiser", Math.ceil(0.5*pkillz-1) );
//			if(100*Math.random() < (pkillz -5) ) system.addShips("galnav-thargbatship", 1);
			if(100*Math.random() < pkillz ) system.addGroup("galnav-thargcruiser", Math.ceil(0.5*pkillz-2) );
			if(100*Math.random() < (pkillz -6) ) system.addShips("galnav-thargbatship", 1);
		}
// Otherwise, the player is in a normal system.
//Possible to do: add code to make patrols vary based on Sector.
	} else {
// Add SecCom System ships if this is a SecCom system.
		if(this.SecComSystemCheck()) this.SecComSystemSetUp();

//Randomly adding in patrols.
//	if(Math.random() > .997) system.addShipsToRoute("patrol-frigate", 1, Math.random(), "wp"); // was .90
	if(Math.random() > .996) system.addShipsToRoute("patrol-boa2", 1, Math.random(), "wp"); // was .90
	if(Math.random() > .995) system.addGroupToRoute("navy-asp", 2, Math.random(), "wp"); // was .90
	if(Math.random() > .99) system.addShipsToRoute("navy-medship", 1, Math.random(), "wp"); // was .90

//Adding a convoy randomly.
//	if(Math.random() > .998) system.addGroup("navy-convoy", 5, Vector3D(0, 0, 0.5).fromCoordinateSystem("wpu"), 5000); // was .85
	if(Math.random() > .997) system.addGroupToRoute("navy-convoy", 5, Math.random(), "wp"); // was .85

//This section adds a carrier battle group. Eric Walch's code made this much better. Full credit to him.
//	if(Math.random() > .998 && system.techLevel > 12) system.addShipsToRoute("navy-behemoth-battlegroup", 1, Math.random(), "wp"); // was .95
	if((Math.random()>.998 && system.techLevel>12)||(Math.random()>.8 && ((galaxyNumber==2 && system.ID==133)||(galaxyNumber==5 && system.ID==41)))||(galaxyNumber==7 && system.ID==162)) system.addShipsToRoute("navy-behemoth-battlegroup", 1, Math.random(), "wp"); // was .95
/*
// Sometimes add a Behemoth that's selling Galactic Hyperdrives (and other equipment) at high prices to unreachable systems!
	if( (galaxyNumber == 2 && system.ID == 133)
//	|| (galaxyNumber == 5 && system.ID == 33)
//	|| (galaxyNumber == 5 && system.ID == 55)
	|| (galaxyNumber == 5 && system.ID == 41)
//	|| (galaxyNumber == 5 && system.ID == 202)
	|| (galaxyNumber == 7 && system.ID == 162)
	){
*/
//Hey, those reserve pilots that are also on the leaderboard do missions too, you know.
	var chance = Math.random();
	if(chance < .06) missionVariables.xaquetl_sortie += 1;
	else if(chance < .11) missionVariables.powers_sortie += 1;
	else if(chance < .16) missionVariables.warrick_sortie += 1;
	else if(chance < .21) missionVariables.zalack_sortie += 1;

//Doing set-up and clean-up after entry into the reserve duty system.
	if(missionVariables.reserve_offer == "OFFER_ACCEPTED") {
		this.reserve_counter_part_two = clock.seconds - missionVariables.reserve_counter;	
//If the player takes too long to get there.
		if(this.reserve_counter_part_two > 1209600) { // 1,209,600 seconds =14 days (2 weeks)
			player.consoleMessage("Gal Navy: The battle at " + missionVariables.reserve_planetname + " is over.");
			player.consoleMessage("Gal Navy: Report to the nearest SecCom station for another assignment.");
			this.ReserveDutyCleanup();
		} else if(system.ID == missionVariables.reserve_planetnum) this.ReserveDutySystemSetUp();
//If the player is in the target system and the battle is still on.
	}
	}
}

this.playerEnteredNewGalaxy = function(galaxyNumber)
{
	if(missionVariables.reserve_status == "STATUS_ENLISTED") player.consoleMessage("Gal Navy: Transferring you to Galaxy " + (galaxyNumber+1) + "'s Naval jurisdiction.");

	var offer = missionVariables.reserve_offer; // working with missionVariables is much slower as with JS variables
	if(offer == "OFFER_ACCEPTED") { // This is really the only case that matters.
		player.consoleMessage("Gal Navy: You have left the galaxy your mission was assigned in.");
		player.consoleMessage("Gal Navy: Please report to the nearest SecCom station for another mission.");
		this.ReserveDutyCleanup();
	}
}

//Stuff to do while docked at a station.
this.missionScreenOpportunity = function()
{
	if(player.ship.docked && player.ship.dockedStation.name == "Navy SecCom Station") this.SecComBusiness();
}
this.shipWillDockWithStation = function(station)
{
	var offer = missionVariables.reserve_offer;
	if(offer == "OFFER_COMPLETED" || offer == "MISSION_ACCOMPLISHED" || offer == "OBJECTIVES_COMPLETE") this.ReserveDutyCleanup();
}

this.shipDockedWithStation = function(station)
{
	if (0 >= oolite.compareVersion("1.75")) {
// for 1.75 onwards we do pilot awarding with a pilot script.
		delete missionVariables.navy_officer_count; // not needed for 1.75
		delete this.shipDockedWithStation;
		return;
	}
// cycle through all rescued officer pilots and add the messages to the report screen.
// Not needed for Oolite 1.75+
	if (missionVariables.navy_officer_count > 0) this.OfficerRescueReward();
}

//Rewards player for rescue of navy officers.
this.OfficerRescueReward = function()
{
	while (missionVariables.navy_officer_count > 0) {
		missionVariables.navy_officer_count--;
		this.unloadOfficer();
	}
}

this.unloadOfficer = function()
{
	var count = Math.ceil(Math.random()*10);
	var payout, message;
	switch(count)
	{
		case 1:
			message = "2lt_insurance_payment";
			payout = 100.0;
			break;
		case 2:
			message = "1lt_insurance_payment";
			payout = 250.0;
			break;
		case 3:
		case 4:
			message = "cpt_insurance_payment";
			payout = 500.0;
			break;
		case 5:
		case 6:
			message = "radm_insurance_payment";
			payout = 750.0;
			break;
		case 7:
		case 8:
			message = "vadm_insurance_payment";
			payout = 1000.0;
			break;
		case 9:
		case 10:
			message = "adm_insurance_payment";
			payout = 2500.0;
			break;
	}
	player.addMessageToArrivalReport(expandMissionText(message));
	player.credits += payout;
}

//This deals with business on SecCom stations.
this.SecComBusiness = function(choice)
{
	switch(missionVariables.seccom_station)
	{
		case "SECCOM_REVISIT": // value is reset by launching from seccom station with station script.
		{
			var seccom_welcome_screen;
			var vicbond_count = Math.floor(missionVariables.vicbond_count / 25);
			switch(vicbond_count)
			{
//Setting welcome screen based on how much support they gave to the Navy.
				case 0:
					seccom_welcome_screen = "seccom_welcome1";
					break;

				case 1:
					seccom_welcome_screen = "seccom_welcome2";
					player.ship.fuel = 7.0;
					break;

				case 2:
				case 3:
					seccom_welcome_screen = "seccom_welcome3";
					player.ship.fuel = 7.0;
					break;

				default :
					seccom_welcome_screen = "seccom_welcome4";
					player.ship.fuel = 7.0;
					break;
			}
			mission.runScreen({title: "Galactic Navy", messageKey: seccom_welcome_screen, choicesKey: "seccom_welcome_choice"}, this.SecComBusiness);
			missionVariables.seccom_station = "SECCOM_VISIT";
			break;
		}
	
// The numbers in front of the cases is to ensure that they display in a logical order in the mission screen.
		case "SECCOM_VISIT":
		{
			switch(choice)
			{
//This section handles the buying of victory bonds.
				case "1buy_vicbond":
				{
					mission.runScreen({title: "Galactic Navy", messageKey: "buy_victory_bonds", choicesKey: "vicbond_purchase_choice"}, this.SecComBusiness);
					break;
				}

				case "1one_vicbond":
				{
					if(player.credits >= 1000.0) {
						player.credits -= 1000;
						missionVariables.vicbond_count++;
						mission.runScreen({title: "Galactic Navy", messageKey: "victory_bond_purchased", overlay: "vicbond.png", choicesKey: "vicbond_purchase_choice2"}, this.SecComBusiness);
					} else mission.runScreen({title: "Galactic Navy", messageKey: "no_cash_for_bond", choicesKey: "vicbond_purchase_choice3"}, this.SecComBusiness);
					break;
				}

				case "2no_vicbond":
				{
					mission.runScreen({title: "Galactic Navy", messageKey: "vicbond_not_purchased", choicesKey: "vicbond_purchase_choice3"}, this.SecComBusiness);
					break;
				}
//End victory bond buying section.

//This section handles the checking of news.
				case "2check_newsbrief":
				{
					mission.runScreen({title: "Galactic Navy", messageKey: "seccom_newsbrief", choicesKey: "seccom_newsbrief_choice"}, this.SecComBusiness);
					break;
				}
//End checking of news section.

//Begin reserve duty section.
				case "3check_reserveduty":
				{
					if(missionVariables.reserve_offer == "OFFER_OPEN") {
						switch(missionVariables.reserve_status)
						{
							case "STATUS_CIVILIAN":
							{
//Begin checks to determine if the player is ready to sign up.
								if(player.score < 8) //This guy's just harmless. He should be in a nursery.
									mission.runScreen({title: "Galactic Navy", messageKey: "seccom_harmless", choicesKey: "seccom_green_choice"}, this.SecComBusiness);

								else if(player.score < 16) //This guy's mostly harmless. He should stick to the milk runs.
									mission.runScreen({title: "Galactic Navy", messageKey: "seccom_mostlyharmless", choicesKey: "seccom_green_choice"}, this.SecComBusiness);

								else if(player.score < 32) //This guy's poor. This is the Navy, not the Trader's Guild.
									mission.runScreen({title: "Galactic Navy", messageKey: "seccom_poor", choicesKey: "seccom_green_choice"}, this.SecComBusiness);

								else if(player.score < 64) //This guy's merely average. Still a ways to go.
									mission.runScreen({title: "Galactic Navy", messageKey: "seccom_average", choicesKey: "seccom_green_choice"}, this.SecComBusiness);

								else if(player.score < 128) //This guy's above average. Not quite yet there.
									mission.runScreen({title: "Galactic Navy", messageKey: "seccom_aboveaverage", choicesKey: "seccom_green_choice"}, this.SecComBusiness);

								else 								//This guy's finally competent enough to fly with us.
									mission.runScreen({title: "Galactic Navy", messageKey: "seccom_reserve_enlist", choicesKey: "reserve_enlist_choice"}, this.SecComBusiness);

								break;
							}

//Giving the player their mission.
							case "STATUS_ENLISTED":
							{
								missionVariables.reserve_offer = "OFFER_ACCEPTED";
								missionVariables.reserve_counter = clock.seconds;
								missionVariables.reserve_planetnum = this.ReserveDutySystemDetermination();
								missionVariables.reserve_planetname = System.systemNameForID(missionVariables.reserve_planetnum);
								missionVariables.reserve_duty = this.ReserveDutyDetermination();
								mission.markSystem(missionVariables.reserve_planetnum);

								switch(missionVariables.reserve_duty)
								{
									case "SYSTEM_INVASION":
									{
										mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_invasion", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
										mission.setInstructionsKey("system_invasion_desc");
										break;
									}

									case "SYSTEM_INVASION2":
									{
										mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_invasion", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
										mission.setInstructionsKey("system_invasion_desc");
										break;
									}

									case "POLICE_ACTION":
									{
										mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_police", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
										mission.setInstructionsKey("police_action_desc");
										break;
									}

									case "FLEET_INTERCEPT":
									{
										mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_fleet", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
										mission.setInstructionsKey("fleet_intercept_desc");
										break;
									}
								}

								break;
							}
						}

//Gives the player an update on the mission.
					} else if(missionVariables.reserve_offer == "OFFER_ACCEPTED") {
						switch(missionVariables.reserve_duty)
						{
							case "SYSTEM_INVASION":
							{
								mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_invasion_reminder", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
								break;
							}

							case "SYSTEM_INVASION2":
							{
								mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_invasion_reminder", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
								break;
							}

							case "POLICE_ACTION":
							{
								mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_police_reminder", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
								break;
							}

							case "FLEET_INTERCEPT":
							{
								mission.runScreen({title: "Galactic Navy", messageKey: "reserve_duty_intercept_reminder", choicesKey: "seccom_reserveduty_choice"}, this.SecComBusiness);
								break;
							}
							default :
							{
								// something went wrong. There was no valid accepted_offer. Show a news brief instead.
								missionVariables.reserve_offer = "OFFER_OPEN";
								mission.runScreen({title: "Galactic Navy", messageKey: "seccom_newsbrief", choicesKey: "seccom_newsbrief_choice"}, this.SecComBusiness);
								break;
							}
						}
					}
					break;
				}

				case "1reserve_sign_me_up":
				{
					mission.runScreen({title: "Galactic Navy", messageKey: "seccom_reserve_intro", choicesKey: "reserve_intro_choice"}, this.SecComBusiness);
					missionVariables.reserve_status = "STATUS_ENLISTED";
					break;
				}

				case "2reserve_not_now":
				{
					mission.runScreen({title: "Galactic Navy", messageKey: "seccom_reserve_pass", choicesKey: "seccom_green_choice"}, this.SecComBusiness);
					break;
				}

				case "3check_leaderboard":
				{
					var message = expandMissionText("squad_leaderboard", {score_number: player.score});
					mission.runScreen({title: "Galactic Navy", message: message, choicesKey: "leaderboard_return_choice"}, this.SecComBusiness);
//					mission.runScreen({title: "Galactic Navy", messageKey: "squad_leaderboard", choicesKey: "leaderboard_return_choice"}, this.SecComBusiness);
					break;
				}
//End reserve duty section.

				case "4back_to_business":
				{
					missionVariables.seccom_station = "DOING_BUSINESS";
					break;
				}
			}
			break;				
		}

		case "DOING_BUSINESS":
		{
			var playersortie = missionVariables.player_sortie;
			if(playersortie % 10 == 0) { // Every ten reserve sorties.
				var bonus = "reserve_bonus" + playersortie;
				var old_bonus = "reserve_bonus" + (playersortie - 10);
		
				if(playersortie == 10 && missionVariables[bonus] == undefined) { // First bonus.
					mission.runScreen({title: "Galactic Navy", messageKey: "reserve_bonus1"});
					player.credits += 1000.0;
					missionVariables[bonus] = "PAID";
				}

				if(playersortie >= 20 && playersortie < 50 && missionVariables[bonus] == undefined) { // Bonuses 2, 3, and 4.
					mission.runScreen({title: "Galactic Navy", messageKey: "reserve_bonus5"});
					player.credits += 5000.0;
					missionVariables[bonus] = "PAID";
					delete missionVariables[old_bonus];
				}

				if(playersortie >= 50 && playersortie % 100 != 0 && missionVariables[bonus] == undefined) { // Bonuses 5 through 9.
					mission.runScreen({title: "Galactic Navy", messageKey: "reserve_bonus10"});
					player.credits += 10000.0;
					missionVariables[bonus] = "PAID";
					delete missionVariables[old_bonus];
				}

				if(playersortie >= 50 && playersortie % 100 == 0 && missionVariables[bonus] == undefined) { // Bonuses 10 and onwards.
					mission.runScreen({title: "Galactic Navy", messageKey: "reserve_bonus25"});
					player.credits += 25000.0; // every 100 missions an extra bonus
					missionVariables[bonus] = "PAID";
					delete missionVariables[old_bonus];
				}
// Eric: it would have been easier when Matt used just one single mission variable to store the status and not a new mission variable for each award stage.
// I now changed the code so that old variables are deleted as they have no longer any use.
// As bonus will this code now go on and not stop after 100 missions. I can't change the way of storing to stay compatible with old save games.
			}
			break;
		}
	}
}

this.ReserveDutySystemDetermination = function()
{
	var thisSystem = system.info;

//	var targetSystems = SystemInfo.systemsInRange(20); // this only looks at direct distances, not by routes.
	var targetSystems = SystemInfo.systemsInRange(30); // this only looks at direct distances, not by routes.

	if (!targetSystems) return system.ID; // choose current system, should never happen.

	var count = targetSystems.length;
	var targetSystem = targetSystems[Math.floor(Math.random()*count)];
	var realDistance = System.infoForSystem(galaxyNumber, targetSystem.systemID).routeToSystem(thisSystem).distance;
	var i = 0;
//	while ((!realDistance || realDistance > 20) && i<count)
	while ((!realDistance || realDistance > 40) && i<count) {
// Make sure there is a short route to the system. If not, the system must be in another sector.
// distance == null for systems in isolated areas.
		targetSystem = targetSystems[i++];
		realDistance = System.infoForSystem(galaxyNumber, targetSystem.systemID).routeToSystem(thisSystem).distance;
	}
	return targetSystem.systemID;
}

//This sets up the mission systems when the player enters them.
this.ReserveDutySystemSetUp = function()
{
	var pkillz = Math.log(player.score); // this only runs if player.score >127, so NO chance of Log(0) = undefined errors!
	switch(missionVariables.reserve_duty)
	{
		case "SYSTEM_INVASION":
		{
			system.addShips("navy-behemoth", 1, Vector3D(0, 0, 0.5).fromCoordinateSystem("wpu"), 1);
//			system.addShips("navy-frigate", 1, Vector3D(0, 0, 0.51).fromCoordinateSystem("wpu"), 1);
//			system.addShips("navy-frigate", 1, Vector3D(0, 0, 0.49).fromCoordinateSystem("wpu"), 1);

			system.addGroup("navy-boa2", 2, Vector3D(0, 0, 0.51).fromCoordinateSystem("wpu"), 1);
			system.addShips("reserve-leader", 1, Vector3D(0, 0, 0.02).fromCoordinateSystem("wpu"), 1);
			system.addGroup("reserve-ship", Math.min(10,Math.ceil(pkillz)), Vector3D(0, 0, 0.01).fromCoordinateSystem("wpu"), 1000); // was 4!

			for (var i=0; i<6; i++) {
			var thargoidGroup = new ShipGroup("Thargoid invasion");
			this.addToGroup(system.addShipsToRoute("galnav-thargoid", Math.min(5,Math.ceil(pkillz*0.5)), 0.166*i, "wp"), thargoidGroup); // was 3
			this.addToGroup(system.addShipsToRoute("galnav-thargcruiser", 1, 0.166*i, "wp"), thargoidGroup);
			if( pkillz > 8-Math.random()*3 ) this.addToGroup(system.addShipsToRoute("galnav-thargbatship", 1, 0.166*i, "wp"), thargoidGroup);
			}
			this.reserve_enemy_ships = 20;	// was 30
			break;
		}

//	Added smaller Thargoid System Invasion variant which lacks official Gal. Navy ships (only has reserves) to fight it.
		case "SYSTEM_INVASION2":
		{
			system.addShips("reserve-leader", 1, Vector3D(0, 0, 0.02).fromCoordinateSystem("wpu"), 1);
			system.addGroup("reserve-ship", Math.min(10,Math.ceil(pkillz)), Vector3D(0, 0, 0.01).fromCoordinateSystem("wpu"), 1000); // was 4!

			var thargoidGroup = new ShipGroup("Thargoid invasion");
			this.addToGroup(system.addShipsToRoute("galnav-thargoid", Math.min(6,Math.ceil(pkillz*0.5)), 0.2, "wp"), thargoidGroup); // was 3
			this.addToGroup(system.addShipsToRoute("galnav-thargcruiser", 1, 0.2, "wp"), thargoidGroup);
			if( pkillz > 9-Math.random()*4 ) this.addToGroup(system.addShipsToRoute("galnav-thargbatship", 1, 0.2, "wp"), thargoidGroup);
			this.reserve_enemy_ships = 5;
			break;
		}

		case "FLEET_INTERCEPT":
		{
			var pos1 = Vector3D(0, 0, -0.03).fromCoordinateSystem("wpu"); // intercept pilots
			system.addShips("intercept-behemoth", 1, pos1, 5000);
//			system.addGroup("intercept-frigate", 2, pos1, 5000);
			system.addGroup("intercept-boa2", Math.min(5,Math.floor(pkillz*0.5)), pos1, 5000); // was 2
			system.addGroup("intercept-transport", Math.min(5,Math.ceil(pkillz*0.5)), pos1, 5000); // was 3
			system.addShips("intercept-sweeper", 1, pos1, 5000);
			system.addGroup("picket-reserve", Math.min(12,2+Math.ceil(pkillz)), pos1, 1000); // was 5!
			system.addShips("reserve-talker", 1, pos1, 5000);

			var pos2 = Vector3D(0, 0, -0.15).fromCoordinateSystem("wpu"); // thargoid fleet.
			var thargoidGroup = new ShipGroup("Thargoid fleet");
			this.addToGroup(system.addShips("galnav-thargoid", Math.min(15,Math.ceil(pkillz*1.5)), pos2, 5000), thargoidGroup); // was 15!
			this.addToGroup(system.addShips("galnav-thargcruiser", Math.min(10,Math.ceil(pkillz)), pos2, 5000), thargoidGroup); // was 10!
			this.addToGroup(system.addShips("galnav-thargbatship", Math.min(5,Math.floor(pkillz*0.5)), pos2, 5000), thargoidGroup); // was 5!
			this.reserve_enemy_ships = 20;	// was 30
			break;
		}

		case "POLICE_ACTION":
		{
			var hp = system.addShipsToRoute("reserve-hideout", 1, 0.1+Math.random()*0.2, "wp")[0].position;
//			system.addShips("pirate-frigate", 1, hp, 5000);
			system.addShips("pirate-boa2", 1, hp, 5000);
			system.addGroup("reserve-pirate", Math.min(12,Math.ceil(pkillz+Math.random()*4)), hp, 5000); // was 8!
//			system.addGroup("reserve-pirate", Math.min(15,Math.ceil(pkillz*2)-2), hp, 5000); // was 8!
//			system.addShips("asteroid", 8, Vector3D(0, 0, 0.2).fromCoordinateSystem("wpu"), 10000);
			system.addShips("asteroid", 8, hp, 20000); // was only 10000 radius from the reserve-hideout
			system.addShips("reserve-lead", 1, [hp.x, hp.y, 15E3], 1); // add them on an interception course.
			system.addGroup("reserve-wingman", Math.min(8,Math.ceil(pkillz-Math.random()*2)), [hp.x, hp.y, 10E3], 1000); // was 4!
//			system.addGroup("reserve-wingman", Math.min(8,Math.ceil(pkillz)-1), [hp.x, hp.y, 10E3], 1000); // was 4!
			this.reserve_enemy_ships = 8;	// was 10
			break;
		}
	}
}

// Initially, when the player has few kills, I want POLICE_ACTION to be the most common, followed by SYSTEM_INVASION (because Thargoids are spread far out), followed by SYSTEM_INVASION2 (Gal. Navy still majority of ships and not need purely Reserve forces), and rarest is FLEET_INTERCEPT (where Thargoids organize into a rare, huge attack force).
this.ReserveDutyDetermination = function()
{
	var chance = 100*Math.random();
	var pkillz = Math.min(10,Math.log(player.score+1));
//	return "SYSTEM_INVASION2"; // for TESTING ONLY!

	if(chance < Math.ceil(pkillz*4)-10) return "SYSTEM_INVASION2"; // lesser System Invasion split off original type.  Runs from ~10% to ~30%, increasing from ~10% chance to ~30% chance
	else if(chance < 20+Math.ceil(pkillz*2)) return "SYSTEM_INVASION"; // was < .34  Now runs from ~30% to ~40%, decreasing from ~20% chance to ~10% chance
	else if(chance < Math.ceil(pkillz*8)) return "FLEET_INTERCEPT"; // was < .66  Now runs from ~40% to ~80%, increasing from ~10% chance to ~40% chance
	else return "POLICE_ACTION";	// was +.66 to .99 for ~33% chance  Now runs starting from ~40% to ~80%, decreasing from ~60% chance to ~20% chance

// This really begs for a "the system you're in is invaded! launch now!!!" reserve duty mission, but only after >10 missions and/or high player.score
}

//Cleans up the reserve duty variables in order to prevent oddities.
this.ReserveDutyCleanup = function()
{
		var message1 = "The battle at " + missionVariables.reserve_planetname + " is over.";
		var message2 = "Reserve pilots may now leave the system.";
	
	if(missionVariables.reserve_offer == "OFFER_COMPLETED") {
		if (player.ship.docked && player.ship.status == "STATUS_DOCKING") {
			player.addMessageToArrivalReport("Gal Navy: " + message1 + " " + message2);
		} else {
			player.commsMessage("Gal Navy: " + message1);
			player.commsMessage("Gal Navy: " + message2);
		}
	}
	mission.setInstructionsKey(null);
	mission.unmarkSystem(missionVariables.reserve_planetnum);
	missionVariables.reserve_offer = "OFFER_OPEN";
	missionVariables.reserve_duty = null;
	missionVariables.reserve_planetnum = null;
	missionVariables.reserve_planetname = null;
	missionVariables.reserve_counter = 0;
	missionVariables.reserve_targets = 0;
	this.reserve_enemy_ships = 0;
}

// Merge ships into one group. Mainly used for Thargoids to minimise friendly attacks,
// because laserhits within a group are ignored in 90% of the cases.
this.addToGroup = function(ships, group)
{
	if (!ships || !group) return;
	for (var i = 0; i < ships.length; i++) {
		group.addShip(ships[i]);
		ships[i].group = group;
	}
}

// Code below is used by ship scripts to control chatter. Courtesy of Eric Walch.
this.messageTime = clock.absoluteSeconds // for use of spacing NPC messages by ship scripts.

this.messageAllowed = function()
{
	if((clock.absoluteSeconds - this.messageTime) > 10) {
		this.messageTime = clock.absoluteSeconds;
		return true;
	} else return false;
}

// Check to see if the system is a Sector Command system.
this.SecComSystemCheck = function()
{
	switch(galaxyNumber)
	{
		case 0:
		{
// Massive Base Closures!
/*
			if(system.ID == 24 ||
			system.ID == 193 ||
			system.ID == 154 ||
			system.ID == 188 ||
			system.ID == 125 ||
			system.ID == 109 ||
			system.ID == 249 ||
			system.ID == 150 ||
			system.ID == 80 ||
			system.ID == 175 ||
			system.ID == 120 ||
			system.ID == 220 ||
			system.ID == 158 ||
			system.ID == 15)
*/
			if(system.ID == 7 ||	// put one also at Lave?!
			system.ID == 24 ||
			system.ID == 150 || // Xeer shipyards!
			system.ID == 175 ||
			system.ID == 120)
				return true;
			else break;
		}

		case 1:
		{
/*
			if(system.ID == 248 ||
			system.ID == 135 ||
			system.ID == 106 ||
			system.ID == 82 ||
			system.ID == 150 ||
			system.ID == 182 ||
			system.ID == 33 ||
			system.ID == 48 ||
			system.ID == 227 ||
			system.ID == 96 ||
			system.ID == 127 ||
			system.ID == 202 ||
			system.ID == 243 ||
			system.ID == 170)
*/
			if(system.ID == 106 ||
			system.ID == 82 ||
			system.ID == 33 || // Main base?
			system.ID == 127 ||
			system.ID == 243)
				return true;
			else break;
		}

		case 2:
		{
/*
			if(system.ID == 31 ||
			system.ID == 165 ||
			system.ID == 245 ||
			system.ID == 84 ||
			system.ID == 36 ||
			system.ID == 21 ||
			system.ID == 26 ||
			system.ID == 139 ||
			system.ID == 251 ||
			system.ID == 205 ||
			system.ID == 223 ||
			system.ID == 204 ||
			system.ID == 17 ||
			system.ID == 247)
*/
			if(system.ID == 31 ||
			system.ID == 36 || // Birera huge GN base!
			system.ID == 69 || // was 139!
			system.ID == 132 || // was 205!
			system.ID == 17)
				return true;
			else break;
		}

		case 3:
		{
/*
			if(system.ID == 39 ||
			system.ID == 221 ||
			system.ID == 188 ||
			system.ID == 86 ||
			system.ID == 9 ||
			system.ID == 57 ||
			system.ID == 186 ||
			system.ID == 237 ||
			system.ID == 49 ||
			system.ID == 103 ||
			system.ID == 254 ||
			system.ID == 66 ||
			system.ID == 140 ||
			system.ID == 110)
*/
			if(system.ID == 197 || // was 39!
			system.ID == 186 || // Main base?
			system.ID == 229 || // was 188!
			system.ID == 66 ||
			system.ID == 69) // was 254!
				return true;
			else break;
		}

		case 4:
		{
/*
			if(system.ID == 249 ||
			system.ID == 71 ||
			system.ID == 57 ||
			system.ID == 144 ||
			system.ID == 198 ||
			system.ID == 153 ||
			system.ID == 204 ||
			system.ID == 73 ||
			system.ID == 102 ||
			system.ID == 222 ||
			system.ID == 29 ||
			system.ID == 233 ||
			system.ID == 152||
			system.ID == 190)
*/
			if(system.ID == 249 ||
			system.ID == 153 ||
			system.ID == 198 || // Main base?
			system.ID == 121 || // was 29!
			system.ID == 190)
				return true;
			else break;
		}

		case 5:
		{
/*
			if(system.ID == 151 ||
			system.ID == 227 ||
			system.ID == 6 ||
			system.ID == 51 ||
			system.ID == 60 ||
			system.ID == 129 ||
			system.ID == 8 ||
			system.ID == 53 ||
			system.ID == 85 ||
			system.ID == 120 ||
			system.ID == 208 ||
			system.ID == 220 ||
			system.ID == 146 ||
			system.ID == 66)
*/
			if(system.ID == 6 ||
			system.ID == 129 ||
			system.ID == 85 || // Main base?
			system.ID == 146 ||
			system.ID == 66)
				return true;
			else break;
		}

		case 6:
		{
/*
			if(system.ID == 214 ||
			system.ID == 161 ||
			system.ID == 250 ||
			system.ID == 127 ||
			system.ID == 23 ||
			system.ID == 154 ||
			system.ID == 234 ||
			system.ID == 24 ||
			system.ID == 55 ||
			system.ID == 64 ||
			system.ID == 231 ||
			system.ID == 140 ||
			system.ID == 202 ||
			system.ID == 35)
*/
			if(system.ID == 161 ||
			system.ID == 86 || // was 127!
			system.ID == 154 ||
			system.ID == 231 || // Main base?
			system.ID == 216) // was 140!
				return true;
			else break;
		}

		case 7:
		{
/*
			if(system.ID == 26 ||
			system.ID == 218 ||
			system.ID == 9 ||
			system.ID == 174 ||
			system.ID == 156 ||
			system.ID == 251 ||
			system.ID == 75 ||
			system.ID == 136 ||
			system.ID == 184 ||
			system.ID == 87 ||
			system.ID == 212 ||
			system.ID == 116 ||
			system.ID == 98 ||
			system.ID == 55)
*/
			if(system.ID == 26 ||
			system.ID == 9 ||
			system.ID == 251 || // Main base?
			system.ID == 116 ||
			system.ID == 113) // was 55!
				return true;
			else break;
		}

		default:
		{
			return false;
		}
	}

	return false;
}

// CHANGE the Sector Command base to somewhere NOT near the planet or along the main space route.
// Code to set up a Sector Command System.
this.SecComSystemSetUp = function()
{
	var victory_bond_count = missionVariables.vicbond_count;
//	var pos1 = Vector3D(0, 0, 2).fromCoordinateSystem("psp"); // SecCom station position.
	var pos1 = Vector3D(0, 0, 0.3).fromCoordinateSystem("psu") // SecCom station position.
//	var pos2 = Vector3D(0, 0, 2.2).fromCoordinateSystem("psp"); // Between the SecCom station and the sun.
//	var pos3 = Vector3D(0, 0, 0.01).fromCoordinateSystem("wpu"); // Witchpoint guard position.

	if(victory_bond_count >= 100) system.addShips("navystat75", 1, pos1, 0)	// If they have 100 or more victory bonds, they get the 75% discount station. - changed to 90% normal prices
	else if(victory_bond_count >=50 && victory_bond_count < 100) system.addShips("navystat50", 1, pos1, 0)	// 50 to 99, 50%. - changed to 95% normal prices
	else if(victory_bond_count >= 25 && victory_bond_count < 50) system.addShips("navystat25", 1, pos1, 0)	// 25 to 49, 25%. - changed to 100% normal prices
	else system.addShips("navystat", 1, pos1, 0); // Less than 25, no discount. - changed to 110% normal prices

// Rather than being a fixed number of ships, the random totalships now represents whether the fleet is at the base or "out on maneuvers".
//	var totalships = Math.max(1,Math.ceil(1 + Math.random()*10 - Math.log(player.score+1)));
	var totalships = Math.max(3,Math.ceil(1 + (Math.random()+Math.random())*10 - Math.random()*Math.log(player.score+1)));
//	if(totalships <1) totalships = 1;
// If missions are available but not already selected, increase totalships slightly.
	if(missionVariables.reserve_offer == "OFFER_OPEN" || player.score < 128 ) totalships += Math.ceil(Math.random()*6);
	
	// Main bases have a Storage Depot ...and more ships if nothing urgent is going on in galaxy sector
	if( (galaxyNumber == 0 && (system.ID == 7 || system.ID == 150))
	|| (galaxyNumber == 1 && system.ID == 33)
	|| (galaxyNumber == 2 && system.ID == 36)
	|| (galaxyNumber == 3 && system.ID == 186)
	|| (galaxyNumber == 4 && system.ID == 198)
	|| (galaxyNumber == 5 && system.ID == 85)
	|| (galaxyNumber == 6 && system.ID == 231)
	|| (galaxyNumber == 7 && system.ID == 251)
	){
// Added to make the area seem more "busy"
//		var x=system.addShips("storagedepot", 1, pos1,9000)[0];
		system.addShips("storagedepot", 1, pos1,9000);

// Increase totalships at main bases further if no major event is going on.
	if( (player.score < 256 || (missionVariables.conhunt == "MISSION_COMPLETE" && missionVariables.thargplans != "PRELUDE" && missionVariables.thargplans != "RUNNING") )
	&& (galaxyNumber != 4 || missionVariables.cloak == "COMPLETE") && missionVariables.reserve_offer != "OFFER_ACCEPTED" ) totalships += Math.max(2,Math.ceil((Math.random()+Math.random())*8 - Math.random()*Math.log(player.score+1)));
/*
	if( (player.score < 256 || (missionVariables.conhunt == "MISSION_COMPLETE" && missionVariables.thargplans != "PRELUDE" && missionVariables.thargplans != "RUNNING") )
	&& (galaxyNumber != 4 || player.ship.equipmentStatus("EQ_CLOAKING_DEVICE") == "EQUIPMENT_OK") ) totalships += Math.max(1,Math.ceil((Math.random()+Math.random())*8 - Math.random()*Math.log(player.score+1)));
player.score > 255 && missionVariables.conhunt != "MISSION_COMPLETE" && galaxyNumber < 2
player.score > 1280 && missionVariables.conhunt == "MISSION_COMPLETE" && galaxyNumber == 2 && missionVariables.thargplans != "PRELUDE" && missionVariables.thargplans != "RUNNING" 
missionVariables.cloakcounter > 0 && galaxyNumber == 4 && scooper.equipmentStatus("EQ_CLOAKING_DEVICE") !== "EQUIPMENT_OK"
	&& (galaxyNumber != 4 || scooper.equipmentStatus("EQ_CLOAKING_DEVICE") == "EQUIPMENT_OK") ) totalships += Math.max(1,Math.ceil(Math.random()*15 - Math.log(player.score+1)));
*/
	}

//	if(totalships <3) totalships = 3;
	var ship1 = Math.max(1,Math.min(totalships-3,Math.round(1 + Math.random()*2)));
//	var ship1 = Math.round(1 + Math.random()*2);
//	if(ship1 > totalships) ship1 = 1;
	system.addGroup("picket-minesweeper", ship1, pos1, 5000);
	totalships = totalships - ship1;
	if(totalships > 0) {
		var ship1 = Math.min(totalships,Math.round(1 + Math.random()*6));
//		var ship1 = Math.max(1,Math.min(totalships,Math.round(1 + Math.random()*6)));
//		var ship1 = Math.round(1 + Math.random()*6);
//		if(ship1 > totalships) ship1 = totalships;
		system.addGroup("picket-viper", ship1, pos1, 5000);
		totalships = totalships - ship1;
	}
	if(totalships > 0) {
		var ship1 = Math.min(totalships,Math.round(1 + Math.random()*4));
//		var ship1 = Math.round(1 + Math.random()*4);
//		if(ship1 > totalships) ship1 = 1;
		system.addGroup("picket-transport", ship1, pos1, 5000);
		totalships = totalships - ship1;
	}
	if(totalships > 0) system.addGroup("picket-boa2", totalships, pos1, 8000);
/*
	if(totalships > 0) {
		var ship1 = Math.round(1 + Math.random()*6);
		if(ship1 > totalships) ship1 = totalships;
		system.addGroup("picket-boa2", ship1, pos1, 5000);
	}

	// SecCom Station guards.
//	system.addShips("picket-frigate", 2, pos1, 5000);
//	system.addShips(expandDescription("[galNavy-ship]"), 1, pos2, 0);
//	system.addGroup("picket-boa2", 2, pos1, 5000);
//	system.addGroup("picket-minesweeper", 2, pos1, 5000);
//	system.addGroup("picket-transport", 3, pos1, 5000);

// Added to make the area seem more "busy"
//	var x=system.addShips("storagedepot", 1, pos1,9000)[0];
//	system.addShips("rockhermit", 1, pos1,9000);

	var x=system.addShips("rockhermit", 1, pos1,9000)[0];
	x.displayName = "Navy Storage Depot";
//	x.orientation = [1,0,0,0]; // orientate it along the z-axis like oolite hermits.
	x.bounty = 0;
	x.switchAI("rockHermitAI.plist");
	x.AIState ="GLOBAL";
	x.primaryRole = "rockhermit";
	x.market = "navystat";
//	system.addGroup("asteroid", 9, pos1, 25000);
//	system.addGroup("asteroid", 20, pos1, 50000);

	system.addGroup("asteroid", 20, pos1, 25000);
	system.addGroup("asteroid", 30, pos1, 50000);
	system.addGroup("asteroid", 40, pos1, 100000);

		if(allpiratez[i].AI === "pirateAI.plist") {
			allpiratez[i].switchAI("route1traderAI.plist");
			allpiratez[i].AIState ="HEAD_FOR_PLANET";
			allpiratez[i].primaryRole = "trader";


	//Witchpoint guards.
	if(Math.random() > 0.5) {
//	system.addShips("picket-frigate", 1, pos3, 0);
//	system.addShips("picket-viper", 4, pos3, 500);
	system.addGroup("picket-viper", 4, pos3, 500);
	system.addShips("picket-boa2", 1, pos3, 0);
	}

	//Patrolling Behemoth -- There *ISN'T* enough Behemoths to spare *ANY* for patrols!
//	system.addShipsToRoute("navy-behemoth", 1, Math.random());
	if(Math.random() > 0.1) system.addShipsToRoute("navy-boa2", 1, Math.random());
*/
}